<?php
/********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   			*/
/*                                                                               								*/
/*     This file is part of Uptime Script                                       						*/
/*                                                                               								*/
/*     Uptime Script is free software; you can redistribute it and/or modify     			*/
/*     it under the terms of the GNU General Public License as published by      			*/
/*     the Free Software Foundation; either version 2 of the License, or         			*/
/*     (at your option) any later version.                                      						*/
/*                                                                              								*/
/*     Uptime Script is distributed in the hope that it will be useful,         				*/
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of          		*/
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             	*/
/*     GNU General Public License for more details.                              					*/
/*                                                                               								*/
/*     You should have received a copy of the GNU General Public License         			*/
/*     along with Uptime Script; if not, write to the Free Software              				*/
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA 		*/
/********************************************************************************/
/*                                                                              								*/
/*         Fichier data.php                                      								*/
/*         Cr le 1 dcembre 2006                                                						*/
/*                                                              									*/
/*         Derniere modification: 1 dcembre 2006   - v4.0.0.alpha-rev12           				*/
/*                                                                               								*/
/********************************************************************************/

 class Analyseur {
 	/*
 	 * Analyse de la qualit de la ligne
 	 * @param{String} snr: Marge de Bruit
 	 * @return{int}: le status
 	 */
 	public static function QoL($snr) {
		if($snr > 25) { 
			//  bon	
			return 3;
		}
		elseif($snr > 12) {
			// moyen
			return 2;
		}
		elseif($snr > 9) {
			return 1;	
		}
		elseif($snr > 0) {
			// Trs mauvaise
			return 0;
		}				
		else {
			// Valeur incorrect
			return -1;	
		}	
 	}
 	/*
 	 * Commente la qualit de la ligne
 	 * 
 	 * @param{String} snr: Marge de Bruit
 	 * @return{string}: le commentaire
 	 */
 	public static function QoL_comment($snr) {
		switch(Analyseur::QoL($snr)) {
			case 3:
				return I10N_SNR_GOOD;
			case 2:
				return I10N_SNR_MIDDLE_PLUS;
			case 1:
				return I10N_SNR_MIDDLE_MINUS;	
			case 0:
				return I10N_SNR_BAD;
			default:
				return I10N_INCORRECT_DATA;	
		}	
 	}
 	/*
 	 * Nombre de dsynchronisation
 	 * 
 	 * @param{DataStruct} data: Les donnes du jour
 	 * @return{string}: le commentaire
 	 */
 	public static function synchro($data) {
 		
 	}
 
 	/*
 	 * Analyse du dbit thorique, 
 	 * influenc par la distance au dslam caractris par l'attnuation'
 	 * @param{String} aff: Attnuation
 	 * @return{int}: le status
 	 */
 	public static function Debit($aff) {
		// Prendre en compte le dbit!!
		if($aff > 0 && $aff < 20) {
			// Bon
			return 3;
		} 
		elseif($aff >= 20 && $aff < 35) {
			// Moyen
			return 2;		
		} 
		elseif($aff >= 35 && $aff < 55) {
			// Mauvais
			return 1;			

		}
		elseif($aff >= 55) {
			// Trs Mauvaise
			return 0;
		}		
		else {
			// Valeur incorrect
			return -1;	
		}	
 	}  
 	/*
 	 * Commente le dbit
 	 * @param{String} aff: Attnuation
 	 * @return{string}: le commentaire
 	 */
 	public static function Debit_comment($aff) {
		// Prendre en compte le dbit!!
		switch(Analyseur::Debit($aff)) {
			case 3:
				// Bon
				return sprintf(I10N_AFF_GOOD,$aff);
			case 2:
				// Moyen
				return sprintf(I10N_AFF_MIDDLE_PLUS,$aff);		
			case 1:
				// Mauvais
				return sprintf(I10N_AFF_MIDDLE_MINUS,$aff);
			case 0:
				// Trs Mauvaise
				return sprintf(I10N_AFF_BAD,$aff);
			default:
				// Valeur incorrect
				return I10N_INCORRECT_DATA;	
		}
 	}
 	/*
 	 * Caractrise par un smiley
 	 * @param{String} $val: status
 	 * @return{string}: l'uri du gif 
 	 */
 	public static function toGif($val) {

		switch($val) {
			case 3:
				// Bon
				return "images/mini_green.gif";
			case 2:
				// Moyen
				return "images/mini_blue.gif";	
			case 1:
				// Mauvais
				return "images/mini_orange.gif";
			case 0:
				// Trs Mauvaise
				return "images/mini_red.gif";
			default:
				// Valeur incorrect
				return "images/mini-black.gif";	
		}
 	}		
 }
?>
