<?php
/*********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   */
/*                                                                               */
/*     This file is part of Uptime Script                                        */
/*                                                                               */
/*     Uptime Script is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by      */
/*     the Free Software Foundation; either version 2 of the License, or         */
/*     (at your option) any later version.                                       */
/*                                                                               */ 
/*     Uptime Script is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */ 
/*     GNU General Public License for more details.                              */
/*                                                                               */
/*     You should have received a copy of the GNU General Public License         */ 
/*     along with Uptime Script; if not, write to the Free Software              */
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA */
/*                                                                               */
/*********************************************************************************/
/*         Inspir d'une classe de Sammy Vuillot                                 */
/*         Fichier libraries/SQL/mssql.php                                       */
/*         Derniere modification: 3 sept 2006 - v4.0.0.alpha-rev9                */
/*                                                                               */
/*         Decription:                                                           */
/*           Gestion des requetes SQL                                            */
/*********************************************************************************/
require('AbstractSQL.php');
class SQL extends AbstractSQL {


    public function __construct($hote,$user,$pass,$dbname,$file_path= './logs/',$aff_error = false ) {
         $this->count_query = 0;
         $this->array_temp = array();
         $this->file_path = $file_path;         
         $this->aff_error = $aff_error;
         
         $this->connect($hote,$user,$pass);
         $this->select_bdd($dbname);
    }
    
    public function connect($serveur,$login,$pass) {  
         $this->connexion = @mssql_connect($serveur,$login,$pass);
         if(!$this->connexion) $this->log('Erreur de connexion :'.mssql_get_last_message());
    }

    public function select_bdd($bdd) {
         $select_bd = @mssql_select_db($bdd,$this->connexion);
         if(!$select_bd) $this->log('Impossible de selectionner la base de donne :'.mssql_get_last_message());
    }
	     
    public function query($sql) {  

         $this->count_query++;
         $this->array_temp[] = $sql;
         $req = mssql_query($sql) or exit("Erreur de requete. ".$this->log($sql."\n".mssql_get_last_message()));
         return $req;
    }
    
    public function query_num($sql) {
         $req = $this->query($sql);
         return mssql_num_rows($req);
    } 
    public function num_ligne($req) {
         return mssql_num_rows($req);
    }

    public function array_sql($req,$type='assoc') {
         switch($type)
         {           
              case 'result': return mssql_result($req,0); break;
              case 'array': return mssql_fetch_array($req); break;
              case 'assoc': return mssql_fetch_assoc($req); break;
              case 'row': return mssql_fetch_row($req); break;
         }
    }

    /************************************************/
    /*				LES REQUETES					*/
    /************************************************/
    
    /*
     * Requete d'enregistrement
     * @param{array}  tableau des valeurs

     */
    public function rq_doLog($table,$array) {

		$rq = sprintf("INSERT INTO [%s] (",$table);
		$i=0;
		foreach($array as $key=>$value) {
			$rq = sprintf($rq." [%s] ",$key);
			$i++;
			if($i <= count($array) -1) $rq = $rq.=" , ";
		}
		$rq = $rq.=" ) VALUES ( ";
		$i=0;
		foreach($array as $key=>$value) {
			$rq = sprintf($rq." '%s' ",$value);
			$i++;
			if($i <= count($array) -1) $rq = $rq.=" , ";
		}
		$rq = $rq.=" )";
		return $rq;		 	 
    } // fin rq_doLog()
    
    /*
     * Chercher tous les jours enregistrs
     * @return{string}
     */
    public function rq_getAllDays() {
		 return "SELECT DISTINCT [day] FROM [log] ORDER BY [day] DESC";
    } // fin rq_getAllDays()

	/*
	 * Chercher tous les enregistrements au jour j.
	 * @param{int} $day: le timestamp du jour concern.
	 * @return{string} 
	 */
    public function rq_getFromDay($day) {
		 return sprintf("SELECT * FROM [log] WHERE [day] = %d",$day);
    } // fin rq_getFromDay()   
 
    

	/*
	 * Requete de rcupration des enregistrements des dernires 24 heures
	 * @return{string}
	 */	
    public function rq_getLast24() {
		$min = intval(date('i')/15)*15;
		$yesterday = mktime(date('H'),0,0,date('m'),date('d')-1,date('Y'));
		$today = mktime(date('H'),$min,0,date('m'),date('d'),date('Y'));
		return sprintf("SELECT * FROM [log] WHERE [time] >= %d AND [time] < %d",$yesterday,$today);
    } // fin rq_getLast24()         
}


?>
