<?php
/*********************************************************************************/
/*     Copyright (C) 2004-2005 Jean-Sbastien H. ( ED ) ( Livebox-script.com )   */
/*                                                                               */
/*     This file is part of Uptime Script                                        */
/*                                                                               */
/*     Uptime Script is free software; you can redistribute it and/or modify     */
/*     it under the terms of the GNU General Public License as published by      */
/*     the Free Software Foundation; either version 2 of the License, or         */
/*     (at your option) any later version.                                       */
/*                                                                               */ 
/*     Uptime Script is distributed in the hope that it will be useful,          */
/*     but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/*     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */ 
/*     GNU General Public License for more details.                              */
/*                                                                               */
/*     You should have received a copy of the GNU General Public License         */ 
/*     along with Uptime Script; if not, write to the Free Software              */
/*     Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA */
/*********************************************************************************/
/*                                                                               */
/*         Fichier lib/sagem.php                                        		 */
/*         Cr le 31 aout 2006                                                  */
/*                                                              				 */
/*         Derniere modification: 01 dc 2006   - v4.0.0.alpha-rev12             */
/*                                                                               */
/*********************************************************************************/

require('AbstractLivebox.php');
class Livebox extends AbstractLivebox {

	public $livebox = "Sagem";
	
	/*
	*	@see AbstractLivebox.getData()
	*/
	protected function getData($ip="192.168.1.1",$user="admin",$passwd="admin") {
		$tmp ="";
		$tmp .= htmlentities($this->file_get_contents($ip,$user,$passwd,"/internetservices.html"));
	  	$tmp .= htmlentities($this->file_get_contents($ip,$user,$passwd,"/adslstats.html"));
	  	$tmp .= htmlentities($this->file_get_contents($ip,$user,$passwd,"/voipservices.html"));
	  	$tmp .= htmlentities($this->file_get_contents($ip,$user,$passwd,"/systeminfo.html"));
		$tmp .= htmlentities($this->file_get_contents($ip,$user,$passwd,"/interfacestats.html"));
		return $tmp;
	}
	  
	public function getFirmware() {
		return $this->strAnalyser($this->data,"/var[^a-zA-Z]*v_Soft_version[^0-9]*([a-zA-Z0-9\_]*)/");
	}

	public function getUptime() {
		return $this->calculerUptime($this->data);
	}

	public function getIP() {
		return $this->strAnalyser($this->data,"/var[^a-zA-Z]*v_Adrs_IP[^0-9]*([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3})/");
	}

	public function getSNR() {
		return $this->strAnalyser($this->data,"/var[^a-zA-Z]*v_SNR_near[^0-9]*([0-9\.]*)/");
	}

	public function getAttenuation() {
		return $this->strAnalyser($this->data,"/var[^a-zA-Z]*v_att_near[^0-9]*([0-9\.]*)/");
	}

	public function getSNR_UP() {
		return -1;
	}

	public function getAttenuation_UP() {
		return -1;
	}

	public function getDownload() {
		return $this->strAnalyser($this->data,"/var[^a-zA-Z]*v_downstream[^0-9]*([0-9\.]*)/");
	}

	public function getAttainableDownStream() {
		return -1;
	}

	public function getUpload() {
		return $this->strAnalyser($this->data,"/var[^a-zA-Z]*v_upstream[^0-9]*([0-9\.]*)/");
	}

	public function getAttainableUpStream() {
		return -1;
	}

	public function getVoIP() {
		return $this->strAnalyser($this->data,"/var[^a-zA-Z]*Voip_service[^A-Z]*([A-Z]{2,3})/");
	}

	public function getCRC() {
		return -1;
	}

	public function getCRC_UNCORR() {
		return -1;
	}

	public function getCRC_UP() {
		return -1;
	}

	public function getCRC_UNCORR_UP() {
		return -1;
	}

	public function getStreamOnInterface($interface) {
			/*
			Dtail des captures
				1- Octets entrants <==
				2 - Paquets entrants Unicast
				3 - Paquets entrants Broadcast
				4 - Paquets entrants abandonns
				5 - Erreurs paquets entrants
				6 - Octets sortants <==
				// 7 - Paquets sortants Unicast
				// 8 - Paquets sortants Broadcast
				// 9 - Paquets sortants abandonns
				// 10 - Errors paquets entrants
			*/
		$pattern = sprintf("/%s[^0-9]*([0-9]*)[^0-9]*([0-9]*)[^0-9]*([0-9]*)[^0-9]*([0-9]*)[^0-9]*([0-9]*)[^0-9]*([0-9]*)/",$interface);
		$tmp = preg_match($pattern, $this->data,$matches);
		if($tmp != 0)
			return array($matches[1],$matches[6]);
		else return NULL;
	}

	protected function calculerUptime($str) {
		$this->strAnalyser($this->data,"/v_Cnx_time_H[^0-9]*([0-9]*)/");
	 	$heure = $this->strAnalyser($this->data,"/v_Cnx_time_H[^0-9]*([0-9]*)/");
		$minute = $this->strAnalyser($this->data,"/v_Cnx_time_M[^0-9]*([0-9]*)/");
		return $heure*60+$minute;			 
	}

	private function file_get_contents($host,$user,$passwd,$uri) {
		$response = "";
		if (!($request=fsockopen($host,80,$errno,$errstr))) exit($errstr);
		
		else {
   			socket_set_timeout($request,10);
		   // send request
    		$post ="GET ".$uri."  HTTP/1.1\r\n";
    		$post .= "Authorization: Basic ".base64_encode($user.":".$passwd)."\r\n";
    		$post .="Host: ".$host."\r\n";
    		$post .="User-Agent: PHP Script\r\n";
    		$post .="Content-Type: application/x-www-form-urlencoded\r\n";
			$post .= "Authorization: Basic ".base64_encode($user.":".$passwd)."\r\n";
    		$post .="Connection: close\r\n\r\n";
    	
			// Envoi de la requete
   			fwrite($request,$post);
   			
   			// Lecture de l'entete de la rponse
			$header = "";
			do $header.=fread($request,1); while (!preg_match('/\\r\\n\\r\\n$/',$header));

			// check for chunked encoding
			if (preg_match('/chunked/',$header)) {
	
				do {
					$byte = "";
					$chunk_size="";
			
					do {
						$chunk_size.=$byte;
						$byte=fread($request,1);
					} while (ord($byte)!=10 AND ord($byte)!=13);      // till we match the CR

					fread($request, 1);        // also drop off the LF

					$chunk_size=hexdec($chunk_size); // convert to real number
					if($chunk_size == 0) break;
					$response.=fread($request,$chunk_size);
					fread($request,2);          // ditch the CRLF that trails the chunk
				} while ($chunk_size);        // till we reach the 0 length chunk (end marker)
			} else {
				// check for specified content length
				if (preg_match('/Content\\-Length:\\s+([0-9]*)\\r\\n/',$header,$matches)) {
					$response=fread($request,$matches[1]);
				} else {
					// not a nice way to do it (may also result in extra CRLF which trails the real content???)
					while (!feof($request)) $response .= fread($request, 4096);
				}
			}
			// close connection
			fclose($request);
		}
		return $response;
	}
}
?>